
/*****************************************************************************/
/**       Copyright 1989 by Evans & Sutherland Computer Division            **/
/**                           Mountain View, CA                             **/
/**                                                                         **/
/**                           All Rights Reserved                           **/
/**                                                                         **/
/**    Permission to use, copy, modify, and distribute this software and    **/
/**    its documentation  for  any  purpose  and  without  fee is hereby    **/
/**    granted, provided that the above copyright notice appear  in  all    **/
/**    copies and that both  that  copyright  notice  and  this  permis-    **/
/**    sion  notice appear in supporting  documentation,  and  that  the    **/
/**    name  of Evans & Sutherland  not be used in advertising or publi-    **/
/**    city pertaining to distribution  of the software without  specif-    **/
/**    ic, written prior permission.                                        **/
/**                                                                         **/
/**    EVANS  & SUTHERLAND  DISCLAIMS  ALL  WARRANTIES  WITH  REGARD  TO    **/
/**    THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILI-    **/
/**    TY AND FITNESS, IN NO EVENT SHALL EVANS &  SUTHERLAND  BE  LIABLE    **/
/**    FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY  DAM-    **/
/**    AGES  WHATSOEVER RESULTING FROM  LOSS OF USE,  DATA  OR  PROFITS,    **/
/**    WHETHER   IN  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS    **/
/**    ACTION, ARISING OUT OF OR IN  CONNECTION  WITH  THE  USE  OR PER-    **/
/**    FORMANCE OF THIS SOFTWARE.                                           **/
/*****************************************************************************/
/* Definitions needed to read and interpret the catalog data */

/* Maximum number of catalog entries that can be handled. */
#define MAXCAT 40


/* Structure used to hold each catalog entry */
/* 	Only limited info. is kept for each  */
/* 	All tabs are estimated from left margin */

/* All measurements are in hundredths of inches */

typedef struct {
	char name[20];	/* Ascii name of catalog entry */
	int bold;	/* bold font -- not used */
	int italic;	/* italic font -- not used */
	int firstindent; /* indent for the first line */
	int indent;	/* indent for other lines */
	int ntabs;	/* number of tabs for this entry */
	int tabs[20];	/* indent from left margin for each */
} CAT_ENTRY;


/* Table used for linear searches for entries */
CAT_ENTRY cat_table[MAXCAT];

